#ifndef CalculateWeight_H
#define CalculateWeight_H

#include <algorithm>
#include <cmath>

class CalculateLogLikelihood
{
   public:
      double operator() (int Nij, int Ni, int Nj, int N) const
      {
         double b1=Nj/N;
         double a1=pow(b1, Nij)*pow(1-b1, (Ni-Nij)); 
         double a2=pow(b1, Nj-Nij)*pow(1-b1, N-Ni-Nj+Nij);

         double b2=Nij/Ni;
         double a3=pow(b2, Nij)*pow(1-b2, Ni-Nij);

         double b3=(Nj-Nij)/(N-Ni);
         double a4=pow(b3, Nj-Nij)*pow(1-b3, N-Ni-Nj+Nij);

         double b4=Ni/N;
         double a5=pow(b4, Ni)*pow(1-b4, 0);
         double a6=pow(b4, 0)*pow(1-b4, N-Ni);
         double a7=pow(1.0, Ni)*pow(0.0, 0);
         double a8=pow(0.0, 0)*pow(1.0, N-Ni);
         return log10((a1*a2/a3*a4)/(a5*a6/a7*a8)); 
         return a1;
      }
};

class CalculateUncertaintyCoefficient
{
   public:
      double operator() (int Nij, int Ni, int Nj, int N) const
      {
         double a1=-Ni/N*log(Ni/N)-(N-Ni)/N*log((N-Ni)/N);
         double a2=-Nj/N*log(Nj/N)-(N-Nj)/N*log((N-Nj)/N);
         double a3=-Nij/N*log(Nij/N)-(Nj-Nij)/N*log((Nj-Nij)/N)-(Ni-Nij)/N*log((Ni-Nij)/N)-(N-Nj-Ni)/N*log((N-Nj-Ni)/N);
         return (a2+a1-a3)/((1/2)*(a1+a2));;
      }
};


#endif
