#include <fstream>
#include <string>
#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <sstream>
using namespace std;

#include "MappingResults.h"

//Perform pairwise comparison of Ontology Fingerprints from two groups-OntoFinFile1 and OntoFinFile2
//tau is the threshold for enrichment p-value used in Ontology Fingerprint
//Compile program: g++ MappingResults.cpp calculateSimilarityScore.cpp -o calculateSimilarityScore

int main(int argc, char* argv[])
{
   if (argc != 5)
   {
      cout<<"Usage: "<<argv[0]<<" OntoFinFile1 OntoFinFile2 tau output"<<endl;
      exit(0);
   }

   string dmOnto, s, line, termName;
   double pValue, adjPValue;
   float tau=atof(argv[3]);

   ifstream domain(argv[2]);
   vector<MappingResults> domainMap;
   getline(domain, line, '>');
   double dmPValue;
   while (getline(domain, line, '>'))
   {
     istringstream is(line);
     getline(is, s);
     MappingResults mp(s);
     while(is>>s>>pValue>>adjPValue)
        if (adjPValue<1)
           mp.addEnrichedWithAdjPValue(s, pValue, adjPValue);

     domainMap.push_back(mp);
   }

   int n;
   ofstream out(argv[4]);
   ifstream geneIn(argv[1]);
   getline(geneIn, s, '>');
   while (getline(geneIn, line, '>'))
   {
     istringstream is(line);
     getline(is, s);
     MappingResults mp(s);
     while(is>>termName>>pValue>>adjPValue)
        if (adjPValue<1)
           mp.addEnrichedWithAdjPValue(termName, pValue, adjPValue);

     for (n=0; n<domainMap.size(); ++n)
       mp.calculateSummaryScore(domainMap[n], tau);

     mp.printSummaryScore(out, -1);
   }
 
   return 0;
} 
